@echo off
REM ******************************************************************************
REM  This script is designed to specifically update Windows 10, where the 
REM  AppVerifier binary has been deleted or crashes.
REM  This script has been limited to run on build 10158 only.
REM ******************************************************************************

set PROGFILESDEST=%programfiles%
if defined programfiles(x86) set PROGFILESDEST=%programfiles(x86)%

REM Check for elevation
net session >nul 2>&1
IF %ERRORLEVEL% NEQ 0 (
    ECHO ERROR: You must run this script from an elevated command prompt.
    ECHO        Please start a new command prompt as an Administrator and try again.
    EXIT /B 1
)

:AppvCheck
REM Check to ensure AppVerifier is failing
%SYSTEMROOT%\system32\appverif.exe /? > nul
if %ERRORLEVEL%.==1. 	GOTO :appverifiersuccess
if %ERRORLEVEL%.==9009. GOTO :appverifiermissing
Echo AppVerifier does not run

GOTO :appverifierfails
:appverifierfails
:appverifiermissing
ECHO ******************************************************************************
Echo Copying AppVerifier files....
ECHO ******************************************************************************

REM Copy Win32 files
if EXIST %SYSTEMROOT%\syswow64\Kernel32.dll GOTO :x64
for %%d in (appverif.chm appverif.exe vfbasics.dll vrfcore.dll) do xcopy %~dp0\appverifier32bitexternalroot\%%d    %SYSTEMROOT%\system32 /y > nul

IF ERRORLEVEL 1 GOTO :Error
GOTO :Success

:x64
for %%d in (appverif.chm appverif.exe vfbasics.dll vrfcore.dll) do xcopy %~dp0\appverifier32bitexternalroot\%%d    %SYSTEMROOT%\syswow64 /y > nul
for %%d in (appverif.chm appverif.exe vfbasics.dll vrfcore.dll) do xcopy %~dp0\appverifier64bitexternalroot\%%d    %SYSTEMROOT%\system32 /y > nul

IF ERRORLEVEL 1 GOTO :Error
GOTO :Success


Goto :eof

:appverifiersuccess
ECHO ******************************************************************************
Echo AppVerifier appears to be working correctly.  This script will not help you.
Echo Please contact the forums if you still have issues
Echo http://go.microsoft.com/fwlink/p/?linkid=390054. 
ECHO ******************************************************************************
Echo.

goto :eof

:Error
Echo.
ECHO ******************************************************************************
Echo The script failed to copy over the necessary files.
Echo If you continue to get this error, please search for additional help from  
Echo the developers forum.  http://go.microsoft.com/fwlink/p/?linkid=390054.
Echo.
ECHO ****************************************************************************** 
Echo.

EXIT /B 1

:Success
Echo.
ECHO ******************************************************************************
Echo The script has successfully updated your installation.  
Echo.
ECHO ******************************************************************************
Echo.

GOTO :eof

